C EXERPT FROM NASA7 BENCHMARK
        PROGRAM chotst
        PARAMETER (IDA=250, NMAT=250, M=4, N=40, NRHS=3, F7=78125.,
     $ T30=1073741824.)
        COMMON /ARRAYS/ A(0:IDA, -M:0, 0:N), B(0:NRHS, 0:NMAT, 0:N),
     $   AX(0:IDA, -M:0, 0:N), BX(0:NRHS, 0:NMAT, 0:N)
        DATA it/200/
        la=51455
        lb=41164
        t=78125./1073741824.
        DO k = 0,40
          DO j = (-4),0
            DO i = 0,250
              t=mod(78125.*t,1.)
              ax(i,j,k)=t
 100          CONTINUE 
            ENDDO
          ENDDO
        ENDDO
        DO k = 0,40
          DO j = 0,250
            DO i = 0,3
              t=mod(78125.*t,1.)
              bx(i,j,k)=t
 110          CONTINUE 
            ENDDO
          ENDDO
        ENDDO
c        DO j = 1,it
          CALL copy(la,ax,a)
          CALL copy(lb,bx,b)
C          CALL cholsky(250,250,4,40,a,3,250,b)
          CALL cholsky(4,4,4,4,a,3,4,b)
 120      CONTINUE 
c        ENDDO
        END
        SUBROUTINE copy(n,a,b)
        REAL a(n),b(n)
        DO i = 1,n
          b(i)=a(i)
 100      CONTINUE 
        ENDDO
        RETURN 
        END
C There are two 4-dimensional loop nests
C l loop can be parallellized
        SUBROUTINE cholsky(ida,nmat,m,n,a,nrhs,idb,b)
        REAL a(0:ida,-m:0,0:n),b(0:nrhs,0:idb,0:n),epss(0:256)
        DATA eps/1e-13/
        DO j = 0,n
	  i0 = max(-m, -j)
          DO i = i0,0
            DO jj = i0-i,0
C$doisv
             DO l = 0,nmat
              if (i.eq.0)then
		if (jj.eq.0) then
   2               a(l,i,j)=a(l,i,j)*a(l,0,i+j)
	        else
   3               a(l,i,j)=a(l,i,j)-a(l,jj,i+j)*a(l,i+jj,j)
		endif
              else
	        if (jj.eq.i0) then
   5          	  a(l,0,j)=a(l,0,j)-a(l,jj,j)**2
	        else
		  if(jj.eq.0) then
   1        	    a(l,0,j)=1./sqrt(abs(epss(l)+a(l,0,j)))
	          else
   4        	    epss(l)=eps*a(l,0,j)
		  endif
	        endif
	      endif
             ENDDO
           ENDDO
          ENDDO
        ENDDO
        DO i = 0,nrhs
          DO k = 0,2*n+1
	    if (k.le.n) then
	      i0 = min(m,n-k)
 	    else
	      i0 = min(m,2*n-k+1)
	    endif
            DO jj = 0,i0
C$doisv
              DO l = 0,nmat
		if (k.le.n) then
		  if (jj.eq.0) then
   8          	    b(i,l,k)=b(i,l,k)*a(l,0,k)
		  else
   7                b(i,l,k+jj)=b(i,l,k+jj)-a(l,-jj,k+jj)*b(i,l,k)
		  endif
	        else
		  if (jj.eq.0) then
   9                b(i,l,k)=b(i,l,k)*a(l,0,k)
		  else
   6                b(i,l,k-jj)=b(i,l,k-jj)-a(l,-jj,k)*b(i,l,k)
		  endif
		endif
              ENDDO
            ENDDO
          ENDDO
        ENDDO
        RETURN 
        END
