C file: gauss.f
C function: gauss-jordan elimination program with result check,
C	    operating on a straight a matrix. (every row contains
C    	    the coefficients of an equation)
C behaviour: number of mflops decreases with increasing dimension,
C	    and amount of data communicated between threads increases
C	    proportional to n^3.
C author: BVA, 21.08.96.
        PARAMETER (nmax=1023)
        DIMENSION a(1024,1023),x(1023)
        DIMENSION b(1024,1023),c(1023)
C static a, b, c, x
        REAL a,b,c,x
        DOUBLE PRECISION it0,it1,it2,it3
        REAL mflops,fp_ops,delta
        CHARACTER*20 argv
        INTEGER is_idx1,is_idx2,is_idx3,is_idx4,is_idx5
C Initialize n                                                  
        narg=iargc()
        IF (narg.gt.1) THEN
          CALL getarg(1,argv)
          READ(argv,*) n
        ELSE 
          n=4
        ENDIF
C Initialize a(,)                                               
        OPEN(unit=11,file='gauss.isg.0')
        is_idx1=0
        DO i = 1,n
          WRITE(11,*) is_idx1+1," W ","a",2,i,n+1
          a(i,n+1)=1.0
          DO j = 1,n
            is_idx1=is_idx1+1
            WRITE(11,*) is_idx1,i,j
            IF (i.eq.j) THEN
              WRITE(11,*) is_idx1," W ","a",2,i,j
              a(i,j)=i
            ELSE 
              WRITE(11,*) is_idx1," W ","a",2,i,j
              a(i,j)=3.0*sin(dble(i+j))
            ENDIF
          ENDDO
        ENDDO
C Initialize b(,)                                               
        CLOSE(11) 
        OPEN(unit=11,file='gauss.isg.1')
        is_idx1=0
        DO i = 1,n
          DO j = 1,n+1
            is_idx1=is_idx1+1
            WRITE(11,*) is_idx1,i,j
            WRITE(11,*) is_idx1," R ","a",2,i,j
            WRITE(11,*) is_idx1," W ","b",2,i,j
            b(i,j)=a(i,j)
          ENDDO
        ENDDO
C subtract f times column i from column j, with i and j from 1 to n
        CLOSE(11) 
        OPEN(unit=11,file='gauss.isg.2')
        is_idx1=0
        DO i = 1,n
C$par doall
          DO j = 1,n
            IF (j.ne.i) THEN
Cwrite (*,*) "1 w f"
Cwrite (*,*) "1 r a",j,i
Cwrite (*,*) "1 r a",i,i
              WRITE(11,*) is_idx1+1," R ","a",2,j,i
              WRITE(11,*) is_idx1+1," R ","a",2,i,i
              f=a(j,i)/a(i,i)
              DO k = i+1,n+1
Cwrite (*,*) "2 w a",j,k
Cwrite (*,*) "2 r f"
Cwrite (*,*) "2 r a",j,k
Cwrite (*,*) "2 r a",i,k
                is_idx1=is_idx1+1
                WRITE(11,*) is_idx1,i,j,k
                WRITE(11,*) is_idx1," R ","a",2,j,k
                WRITE(11,*) is_idx1," R ","a",2,i,k
                WRITE(11,*) is_idx1," W ","a",2,j,k
                a(j,k)=a(j,k)-f*a(i,k)
              ENDDO
            ENDIF
          ENDDO
        ENDDO
        it2=it2-it1
C substitution
        CLOSE(11) 
        OPEN(unit=11,file='gauss.isg.3')
        is_idx1=0
        DO i = 1,n
          is_idx1=is_idx1+1
          WRITE(11,*) is_idx1,i
          WRITE(11,*) is_idx1," R ","a",2,i,n+1
          WRITE(11,*) is_idx1," R ","a",2,i,i
          WRITE(11,*) is_idx1," W ","x",1,i
          x(i)=a(i,n+1)/a(i,i)
        ENDDO
        IF (n.eq.10) THEN
          WRITE(11,*) is_idx1+1," R ","x",1,i
          WRITE(*,"(1x, 10f8.3/)") (x(i),i=1,n) 
        ENDIF
C backsubstitution
        CLOSE(11) 
        OPEN(unit=11,file='gauss.isg.4')
        is_idx1=0
        DO i = 1,n
          WRITE(11,*) is_idx1+1," W ","c",1,i
          c(i)=0
          DO j = 1,n
            is_idx1=is_idx1+1
            WRITE(11,*) is_idx1,i,j
            WRITE(11,*) is_idx1," R ","c",1,i
            WRITE(11,*) is_idx1," R ","b",2,i,j
            WRITE(11,*) is_idx1," R ","x",1,j
            WRITE(11,*) is_idx1," W ","c",1,i
            c(i)=c(i)+b(i,j)*x(j)
          ENDDO
          WRITE(11,*) is_idx1+1," R ","c",1,i
          WRITE(11,*) is_idx1+1," R ","b",2,i,n+1
          delta=delta+(c(i)-b(i,n+1))**2
        ENDDO
        it3=it3-it0
        fp_ops=(n-1)*n*(n+2)
        mflops=fp_ops/(1000000.*it2)
        WRITE(*,*) "size: ",n,", average error: ",sqrt(delta)/n
        WRITE(*,*) "total: ",it3,", main loop: ",it2
        WRITE(*,*) "flops: ",fp_ops,", mflops: ",mflops
        END
