CC   tomcatv.f	1.5     (GENIAS)     7/26/91
CC   tomcatv.f	1.6     (SNI)       10/05/94
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC                                                                    CC
CC                          T O M C A T V                             CC
CC                                                                    CC
CC     MESHGENERATION WITH THOMPSON SOLVER,  VECTORIZED VERSION       CC
CC                                                                    CC
CC      SET  N = 65, 129, 257      DO  SCALAR AND VECTOR  RUNS        CC
CC                                                                    CC
C Description of the equations and the finite difference approximation C
CC                               in                                   CC
CC W.Gentzsch, K.Neves and H.Yoshihara: Computational Fluid Dynamics: CC
CC  Algorithms and Supercomputers. AGARDograph No. 311, August 1987   CC
CC                                                                    CC
CC Authors:                                                           CC
CC       W.GENTZSCH FH REGENSBURG  AND  GENIAS SOFTWARE GmbH          CC
CC           Erzgebirgstr. 2, 8402 Neutraubling, Germany              CC
CC                                                                    CC
CC                     Formal modifications by                        CC
CC       F.FERSTL GENIAS SOFTWARE GMBH                                CC
CC           Erzgebirgstr. 2, 8402 Neutraubling, Germany              CC
CC                                                                    CC
CC                                                                    CC
CC	Adapted for PAR93 and SPEC                                    CC
CC	By Bodo Parady                                                CC
CC	November 93                                                   CC
CC                                                                    CC
CC      Adapted for SPEC CFP9                                         CC
CC      By Reinhold Weicker                                           CC
CC      Oct. 1994                                                     CC
CC                                                                    CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
        INTEGER nmax,is_idx1,is_idx2,is_idx3,is_idx4,is_idx5,is_idx6,
     1is_idx7,is_idx8,is_idx9
        PARAMETER (nmax=513)
C     NMAX is the size for the array declarations
C
C     The size of the (sub-)array that is actually used is given by
C     the number N which is read from the input file.
C     The relation N <= NMAX must hold.
C
        INTEGER itmax
        REAL*8 eps,relfa,rel
        PARAMETER (itmax=1000)
        PARAMETER (relfa=0.98d0)
        PARAMETER (rel=2.0d0/relfa)
        PARAMETER (eps=0.5d-8)
C
        INTEGER n,itact
        INTEGER i,j,iter
C
        REAL*8 aa(513,513),dd(513,513),d(513,513)
        REAL*8 x(513,513),y(513,513)
        REAL*8 rx(513,513),ry(513,513)
        REAL*8 rxm(1000),rym(1000)
        REAL*8 dlo,dhi,alpha
        REAL*8 a,b,c,xx,xy,yx,yy
        REAL*8 pxx,qxx,pyy,qyy,pxy,qxy
        REAL*8 r
        REAL*8 abx,aby
C
C     READ INITIAL DATA
C
        REAL cputim1,cputim2
        OPEN(10,file="TOMCATV.MODEL",status="OLD")
   1    CONTINUE 
        READ(5,*) n,itact,dlo,dhi,alpha
        IF (itact.gt.1000.or.n.gt.513) THEN
          PRINT *,"Please recompile:  This version is lacking Storage"
          CALL cputim(cputim2)
          PRINT *,0
          STOP
        ENDIF
C
C     READ START CONFIGURATION
C
        CALL cputim(cputim1)
        OPEN(unit=11,file='tomcatv.isg.0')
        is_idx1=0
        DO j = 1,n
          DO i = 1,n
            is_idx1=is_idx1+1
            WRITE(11,*) is_idx1,j,i
            WRITE(11,*) is_idx1," W ","x",2,i,j
            WRITE(11,*) is_idx1," W ","y",2,i,j
            READ(10,600) x(i,j),y(i,j)
  10        CONTINUE 
          ENDDO
        ENDDO
C
C     START ITERATION LOOP 140
C
CFLIP140
        CLOSE(11) 
        OPEN(unit=11,file='tomcatv.isg.1')
        is_idx1=0
        OPEN(unit=12,file='tomcatv.isg.2')
        is_idx2=0
        OPEN(unit=13,file='tomcatv.isg.3')
        is_idx3=0
        OPEN(unit=14,file='tomcatv.isg.4')
        is_idx4=0
        OPEN(unit=15,file='tomcatv.isg.5')
        is_idx5=0
        OPEN(unit=16,file='tomcatv.isg.6')
        is_idx6=0
        OPEN(unit=17,file='tomcatv.isg.7')
        is_idx7=0
        DO iter = 1,itact
C       
C     Residuals of ITER iteration
C  
          WRITE(11,*) is_idx1+1," W ","rxm",1,iter
          WRITE(12,*) is_idx2+1," W ","rxm",1,iter
          WRITE(13,*) is_idx3+1," W ","rxm",1,iter
          WRITE(14,*) is_idx4+1," W ","rxm",1,iter
          WRITE(15,*) is_idx5+1," W ","rxm",1,iter
          WRITE(16,*) is_idx6+1," W ","rxm",1,iter
          WRITE(17,*) is_idx7+1," W ","rxm",1,iter
          rxm(iter)=0.d0
          WRITE(11,*) is_idx1+1," W ","rym",1,iter
          WRITE(12,*) is_idx2+1," W ","rym",1,iter
          WRITE(13,*) is_idx3+1," W ","rym",1,iter
          WRITE(14,*) is_idx4+1," W ","rym",1,iter
          WRITE(15,*) is_idx5+1," W ","rym",1,iter
          WRITE(16,*) is_idx6+1," W ","rym",1,iter
          WRITE(17,*) is_idx7+1," W ","rym",1,iter
          rym(iter)=0.d0
C
          DO j = 2,n-1
C
            DO i = 2,n-1
              is_idx1=is_idx1+1
              WRITE(11,*) is_idx1,iter,j,i
              WRITE(11,*) is_idx1," R ","x",2,i+1,j
              WRITE(12,*) is_idx2+1," R ","x",2,i+1,j
              WRITE(13,*) is_idx3+1," R ","x",2,i+1,j
              WRITE(14,*) is_idx4+1," R ","x",2,i+1,j
              WRITE(15,*) is_idx5+1," R ","x",2,i+1,j
              WRITE(16,*) is_idx6+1," R ","x",2,i+1,j
              WRITE(17,*) is_idx7+1," R ","x",2,i+1,j
              WRITE(11,*) is_idx1," R ","x",2,i-1,j
              WRITE(12,*) is_idx2+1," R ","x",2,i-1,j
              WRITE(13,*) is_idx3+1," R ","x",2,i-1,j
              WRITE(14,*) is_idx4+1," R ","x",2,i-1,j
              WRITE(15,*) is_idx5+1," R ","x",2,i-1,j
              WRITE(16,*) is_idx6+1," R ","x",2,i-1,j
              WRITE(17,*) is_idx7+1," R ","x",2,i-1,j
              xx=x(i+1,j)-x(i-1,j)
              WRITE(11,*) is_idx1," R ","y",2,i+1,j
              WRITE(12,*) is_idx2+1," R ","y",2,i+1,j
              WRITE(13,*) is_idx3+1," R ","y",2,i+1,j
              WRITE(14,*) is_idx4+1," R ","y",2,i+1,j
              WRITE(15,*) is_idx5+1," R ","y",2,i+1,j
              WRITE(16,*) is_idx6+1," R ","y",2,i+1,j
              WRITE(17,*) is_idx7+1," R ","y",2,i+1,j
              WRITE(11,*) is_idx1," R ","y",2,i-1,j
              WRITE(12,*) is_idx2+1," R ","y",2,i-1,j
              WRITE(13,*) is_idx3+1," R ","y",2,i-1,j
              WRITE(14,*) is_idx4+1," R ","y",2,i-1,j
              WRITE(15,*) is_idx5+1," R ","y",2,i-1,j
              WRITE(16,*) is_idx6+1," R ","y",2,i-1,j
              WRITE(17,*) is_idx7+1," R ","y",2,i-1,j
              yx=y(i+1,j)-y(i-1,j)
              WRITE(11,*) is_idx1," R ","x",2,i,j+1
              WRITE(12,*) is_idx2+1," R ","x",2,i,j+1
              WRITE(13,*) is_idx3+1," R ","x",2,i,j+1
              WRITE(14,*) is_idx4+1," R ","x",2,i,j+1
              WRITE(15,*) is_idx5+1," R ","x",2,i,j+1
              WRITE(16,*) is_idx6+1," R ","x",2,i,j+1
              WRITE(17,*) is_idx7+1," R ","x",2,i,j+1
              WRITE(11,*) is_idx1," R ","x",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","x",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","x",2,i,j-1
              WRITE(14,*) is_idx4+1," R ","x",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","x",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","x",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","x",2,i,j-1
              xy=x(i,j+1)-x(i,j-1)
              WRITE(11,*) is_idx1," R ","y",2,i,j+1
              WRITE(12,*) is_idx2+1," R ","y",2,i,j+1
              WRITE(13,*) is_idx3+1," R ","y",2,i,j+1
              WRITE(14,*) is_idx4+1," R ","y",2,i,j+1
              WRITE(15,*) is_idx5+1," R ","y",2,i,j+1
              WRITE(16,*) is_idx6+1," R ","y",2,i,j+1
              WRITE(17,*) is_idx7+1," R ","y",2,i,j+1
              WRITE(11,*) is_idx1," R ","y",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","y",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","y",2,i,j-1
              WRITE(14,*) is_idx4+1," R ","y",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","y",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","y",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","y",2,i,j-1
              yy=y(i,j+1)-y(i,j-1)
              a=0.25d0*(xy*xy+yy*yy)
              b=0.25d0*(xx*xx+yx*yx)
              c=0.125d0*(xx*xy+yx*yy)
              WRITE(11,*) is_idx1," W ","aa",2,i,j
              WRITE(12,*) is_idx2+1," W ","aa",2,i,j
              WRITE(13,*) is_idx3+1," W ","aa",2,i,j
              WRITE(14,*) is_idx4+1," W ","aa",2,i,j
              WRITE(15,*) is_idx5+1," W ","aa",2,i,j
              WRITE(16,*) is_idx6+1," W ","aa",2,i,j
              WRITE(17,*) is_idx7+1," W ","aa",2,i,j
              aa(i,j)=-b
              WRITE(11,*) is_idx1," W ","dd",2,i,j
              WRITE(12,*) is_idx2+1," W ","dd",2,i,j
              WRITE(13,*) is_idx3+1," W ","dd",2,i,j
              WRITE(14,*) is_idx4+1," W ","dd",2,i,j
              WRITE(15,*) is_idx5+1," W ","dd",2,i,j
              WRITE(16,*) is_idx6+1," W ","dd",2,i,j
              WRITE(17,*) is_idx7+1," W ","dd",2,i,j
              dd(i,j)=2*b+a*rel
              WRITE(11,*) is_idx1," R ","x",2,i+1,j
              WRITE(12,*) is_idx2+1," R ","x",2,i+1,j
              WRITE(13,*) is_idx3+1," R ","x",2,i+1,j
              WRITE(14,*) is_idx4+1," R ","x",2,i+1,j
              WRITE(15,*) is_idx5+1," R ","x",2,i+1,j
              WRITE(16,*) is_idx6+1," R ","x",2,i+1,j
              WRITE(17,*) is_idx7+1," R ","x",2,i+1,j
              WRITE(11,*) is_idx1," R ","x",2,i,j
              WRITE(12,*) is_idx2+1," R ","x",2,i,j
              WRITE(13,*) is_idx3+1," R ","x",2,i,j
              WRITE(14,*) is_idx4+1," R ","x",2,i,j
              WRITE(15,*) is_idx5+1," R ","x",2,i,j
              WRITE(16,*) is_idx6+1," R ","x",2,i,j
              WRITE(17,*) is_idx7+1," R ","x",2,i,j
              WRITE(11,*) is_idx1," R ","x",2,i-1,j
              WRITE(12,*) is_idx2+1," R ","x",2,i-1,j
              WRITE(13,*) is_idx3+1," R ","x",2,i-1,j
              WRITE(14,*) is_idx4+1," R ","x",2,i-1,j
              WRITE(15,*) is_idx5+1," R ","x",2,i-1,j
              WRITE(16,*) is_idx6+1," R ","x",2,i-1,j
              WRITE(17,*) is_idx7+1," R ","x",2,i-1,j
              pxx=x(i+1,j)-2.d0*x(i,j)+x(i-1,j)
              WRITE(11,*) is_idx1," R ","y",2,i+1,j
              WRITE(12,*) is_idx2+1," R ","y",2,i+1,j
              WRITE(13,*) is_idx3+1," R ","y",2,i+1,j
              WRITE(14,*) is_idx4+1," R ","y",2,i+1,j
              WRITE(15,*) is_idx5+1," R ","y",2,i+1,j
              WRITE(16,*) is_idx6+1," R ","y",2,i+1,j
              WRITE(17,*) is_idx7+1," R ","y",2,i+1,j
              WRITE(11,*) is_idx1," R ","y",2,i,j
              WRITE(12,*) is_idx2+1," R ","y",2,i,j
              WRITE(13,*) is_idx3+1," R ","y",2,i,j
              WRITE(14,*) is_idx4+1," R ","y",2,i,j
              WRITE(15,*) is_idx5+1," R ","y",2,i,j
              WRITE(16,*) is_idx6+1," R ","y",2,i,j
              WRITE(17,*) is_idx7+1," R ","y",2,i,j
              WRITE(11,*) is_idx1," R ","y",2,i-1,j
              WRITE(12,*) is_idx2+1," R ","y",2,i-1,j
              WRITE(13,*) is_idx3+1," R ","y",2,i-1,j
              WRITE(14,*) is_idx4+1," R ","y",2,i-1,j
              WRITE(15,*) is_idx5+1," R ","y",2,i-1,j
              WRITE(16,*) is_idx6+1," R ","y",2,i-1,j
              WRITE(17,*) is_idx7+1," R ","y",2,i-1,j
              qxx=y(i+1,j)-2.d0*y(i,j)+y(i-1,j)
              WRITE(11,*) is_idx1," R ","x",2,i,j+1
              WRITE(12,*) is_idx2+1," R ","x",2,i,j+1
              WRITE(13,*) is_idx3+1," R ","x",2,i,j+1
              WRITE(14,*) is_idx4+1," R ","x",2,i,j+1
              WRITE(15,*) is_idx5+1," R ","x",2,i,j+1
              WRITE(16,*) is_idx6+1," R ","x",2,i,j+1
              WRITE(17,*) is_idx7+1," R ","x",2,i,j+1
              WRITE(11,*) is_idx1," R ","x",2,i,j
              WRITE(12,*) is_idx2+1," R ","x",2,i,j
              WRITE(13,*) is_idx3+1," R ","x",2,i,j
              WRITE(14,*) is_idx4+1," R ","x",2,i,j
              WRITE(15,*) is_idx5+1," R ","x",2,i,j
              WRITE(16,*) is_idx6+1," R ","x",2,i,j
              WRITE(17,*) is_idx7+1," R ","x",2,i,j
              WRITE(11,*) is_idx1," R ","x",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","x",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","x",2,i,j-1
              WRITE(14,*) is_idx4+1," R ","x",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","x",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","x",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","x",2,i,j-1
              pyy=x(i,j+1)-2.d0*x(i,j)+x(i,j-1)
              WRITE(11,*) is_idx1," R ","y",2,i,j+1
              WRITE(12,*) is_idx2+1," R ","y",2,i,j+1
              WRITE(13,*) is_idx3+1," R ","y",2,i,j+1
              WRITE(14,*) is_idx4+1," R ","y",2,i,j+1
              WRITE(15,*) is_idx5+1," R ","y",2,i,j+1
              WRITE(16,*) is_idx6+1," R ","y",2,i,j+1
              WRITE(17,*) is_idx7+1," R ","y",2,i,j+1
              WRITE(11,*) is_idx1," R ","y",2,i,j
              WRITE(12,*) is_idx2+1," R ","y",2,i,j
              WRITE(13,*) is_idx3+1," R ","y",2,i,j
              WRITE(14,*) is_idx4+1," R ","y",2,i,j
              WRITE(15,*) is_idx5+1," R ","y",2,i,j
              WRITE(16,*) is_idx6+1," R ","y",2,i,j
              WRITE(17,*) is_idx7+1," R ","y",2,i,j
              WRITE(11,*) is_idx1," R ","y",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","y",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","y",2,i,j-1
              WRITE(14,*) is_idx4+1," R ","y",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","y",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","y",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","y",2,i,j-1
              qyy=y(i,j+1)-2.d0*y(i,j)+y(i,j-1)
              WRITE(11,*) is_idx1," R ","x",2,i+1,j+1
              WRITE(12,*) is_idx2+1," R ","x",2,i+1,j+1
              WRITE(13,*) is_idx3+1," R ","x",2,i+1,j+1
              WRITE(14,*) is_idx4+1," R ","x",2,i+1,j+1
              WRITE(15,*) is_idx5+1," R ","x",2,i+1,j+1
              WRITE(16,*) is_idx6+1," R ","x",2,i+1,j+1
              WRITE(17,*) is_idx7+1," R ","x",2,i+1,j+1
              WRITE(11,*) is_idx1," R ","x",2,i+1,j-1
              WRITE(12,*) is_idx2+1," R ","x",2,i+1,j-1
              WRITE(13,*) is_idx3+1," R ","x",2,i+1,j-1
              WRITE(14,*) is_idx4+1," R ","x",2,i+1,j-1
              WRITE(15,*) is_idx5+1," R ","x",2,i+1,j-1
              WRITE(16,*) is_idx6+1," R ","x",2,i+1,j-1
              WRITE(17,*) is_idx7+1," R ","x",2,i+1,j-1
              WRITE(11,*) is_idx1," R ","x",2,i-1,j+1
              WRITE(12,*) is_idx2+1," R ","x",2,i-1,j+1
              WRITE(13,*) is_idx3+1," R ","x",2,i-1,j+1
              WRITE(14,*) is_idx4+1," R ","x",2,i-1,j+1
              WRITE(15,*) is_idx5+1," R ","x",2,i-1,j+1
              WRITE(16,*) is_idx6+1," R ","x",2,i-1,j+1
              WRITE(17,*) is_idx7+1," R ","x",2,i-1,j+1
              WRITE(11,*) is_idx1," R ","x",2,i-1,j-1
              WRITE(12,*) is_idx2+1," R ","x",2,i-1,j-1
              WRITE(13,*) is_idx3+1," R ","x",2,i-1,j-1
              WRITE(14,*) is_idx4+1," R ","x",2,i-1,j-1
              WRITE(15,*) is_idx5+1," R ","x",2,i-1,j-1
              WRITE(16,*) is_idx6+1," R ","x",2,i-1,j-1
              WRITE(17,*) is_idx7+1," R ","x",2,i-1,j-1
              pxy=x(i+1,j+1)-x(i+1,j-1)-x(i-1,j+1)+x(i-1,j-1)
              WRITE(11,*) is_idx1," R ","y",2,i+1,j+1
              WRITE(12,*) is_idx2+1," R ","y",2,i+1,j+1
              WRITE(13,*) is_idx3+1," R ","y",2,i+1,j+1
              WRITE(14,*) is_idx4+1," R ","y",2,i+1,j+1
              WRITE(15,*) is_idx5+1," R ","y",2,i+1,j+1
              WRITE(16,*) is_idx6+1," R ","y",2,i+1,j+1
              WRITE(17,*) is_idx7+1," R ","y",2,i+1,j+1
              WRITE(11,*) is_idx1," R ","y",2,i+1,j-1
              WRITE(12,*) is_idx2+1," R ","y",2,i+1,j-1
              WRITE(13,*) is_idx3+1," R ","y",2,i+1,j-1
              WRITE(14,*) is_idx4+1," R ","y",2,i+1,j-1
              WRITE(15,*) is_idx5+1," R ","y",2,i+1,j-1
              WRITE(16,*) is_idx6+1," R ","y",2,i+1,j-1
              WRITE(17,*) is_idx7+1," R ","y",2,i+1,j-1
              WRITE(11,*) is_idx1," R ","y",2,i-1,j+1
              WRITE(12,*) is_idx2+1," R ","y",2,i-1,j+1
              WRITE(13,*) is_idx3+1," R ","y",2,i-1,j+1
              WRITE(14,*) is_idx4+1," R ","y",2,i-1,j+1
              WRITE(15,*) is_idx5+1," R ","y",2,i-1,j+1
              WRITE(16,*) is_idx6+1," R ","y",2,i-1,j+1
              WRITE(17,*) is_idx7+1," R ","y",2,i-1,j+1
              WRITE(11,*) is_idx1," R ","y",2,i-1,j-1
              WRITE(12,*) is_idx2+1," R ","y",2,i-1,j-1
              WRITE(13,*) is_idx3+1," R ","y",2,i-1,j-1
              WRITE(14,*) is_idx4+1," R ","y",2,i-1,j-1
              WRITE(15,*) is_idx5+1," R ","y",2,i-1,j-1
              WRITE(16,*) is_idx6+1," R ","y",2,i-1,j-1
              WRITE(17,*) is_idx7+1," R ","y",2,i-1,j-1
              qxy=y(i+1,j+1)-y(i+1,j-1)-y(i-1,j+1)+y(i-1,j-1)
C
C     CALCULATE RESIDUALS ( EQUAL TO RIGHT HAND SIDES OF EQUS.)
C
              WRITE(11,*) is_idx1," W ","rx",2,i,j
              WRITE(12,*) is_idx2+1," W ","rx",2,i,j
              WRITE(13,*) is_idx3+1," W ","rx",2,i,j
              WRITE(14,*) is_idx4+1," W ","rx",2,i,j
              WRITE(15,*) is_idx5+1," W ","rx",2,i,j
              WRITE(16,*) is_idx6+1," W ","rx",2,i,j
              WRITE(17,*) is_idx7+1," W ","rx",2,i,j
              rx(i,j)=(a*pxx+b*pyy)-c*pxy
              WRITE(11,*) is_idx1," W ","ry",2,i,j
              WRITE(12,*) is_idx2+1," W ","ry",2,i,j
              WRITE(13,*) is_idx3+1," W ","ry",2,i,j
              WRITE(14,*) is_idx4+1," W ","ry",2,i,j
              WRITE(15,*) is_idx5+1," W ","ry",2,i,j
              WRITE(16,*) is_idx6+1," W ","ry",2,i,j
              WRITE(17,*) is_idx7+1," W ","ry",2,i,j
              ry(i,j)=(a*qxx+b*qyy)-c*qxy
C
  50          CONTINUE 
            ENDDO
  60        CONTINUE 
          ENDDO
C
C     DETERMINE MAXIMUM VALUES RXM, RYM OF RESIDUALS
C
          DO j = 2,n-1
            DO i = 2,n-1
              is_idx2=is_idx2+1
              WRITE(12,*) is_idx2,iter,j,i
              WRITE(11,*) is_idx1+1," R ","rxm",1,iter
              WRITE(12,*) is_idx2," R ","rxm",1,iter
              WRITE(13,*) is_idx3+1," R ","rxm",1,iter
              WRITE(14,*) is_idx4+1," R ","rxm",1,iter
              WRITE(15,*) is_idx5+1," R ","rxm",1,iter
              WRITE(16,*) is_idx6+1," R ","rxm",1,iter
              WRITE(17,*) is_idx7+1," R ","rxm",1,iter
              WRITE(11,*) is_idx1+1," R ","rx",2,i,j
              WRITE(12,*) is_idx2," R ","rx",2,i,j
              WRITE(13,*) is_idx3+1," R ","rx",2,i,j
              WRITE(14,*) is_idx4+1," R ","rx",2,i,j
              WRITE(15,*) is_idx5+1," R ","rx",2,i,j
              WRITE(16,*) is_idx6+1," R ","rx",2,i,j
              WRITE(17,*) is_idx7+1," R ","rx",2,i,j
              WRITE(11,*) is_idx1+1," W ","rxm",1,iter
              WRITE(12,*) is_idx2," W ","rxm",1,iter
              WRITE(13,*) is_idx3+1," W ","rxm",1,iter
              WRITE(14,*) is_idx4+1," W ","rxm",1,iter
              WRITE(15,*) is_idx5+1," W ","rxm",1,iter
              WRITE(16,*) is_idx6+1," W ","rxm",1,iter
              WRITE(17,*) is_idx7+1," W ","rxm",1,iter
              rxm(iter)=max(rxm(iter),abs(rx(i,j)))
              WRITE(11,*) is_idx1+1," R ","rym",1,iter
              WRITE(12,*) is_idx2," R ","rym",1,iter
              WRITE(13,*) is_idx3+1," R ","rym",1,iter
              WRITE(14,*) is_idx4+1," R ","rym",1,iter
              WRITE(15,*) is_idx5+1," R ","rym",1,iter
              WRITE(16,*) is_idx6+1," R ","rym",1,iter
              WRITE(17,*) is_idx7+1," R ","rym",1,iter
              WRITE(11,*) is_idx1+1," R ","ry",2,i,j
              WRITE(12,*) is_idx2," R ","ry",2,i,j
              WRITE(13,*) is_idx3+1," R ","ry",2,i,j
              WRITE(14,*) is_idx4+1," R ","ry",2,i,j
              WRITE(15,*) is_idx5+1," R ","ry",2,i,j
              WRITE(16,*) is_idx6+1," R ","ry",2,i,j
              WRITE(17,*) is_idx7+1," R ","ry",2,i,j
              WRITE(11,*) is_idx1+1," W ","rym",1,iter
              WRITE(12,*) is_idx2," W ","rym",1,iter
              WRITE(13,*) is_idx3+1," W ","rym",1,iter
              WRITE(14,*) is_idx4+1," W ","rym",1,iter
              WRITE(15,*) is_idx5+1," W ","rym",1,iter
              WRITE(16,*) is_idx6+1," W ","rym",1,iter
              WRITE(17,*) is_idx7+1," W ","rym",1,iter
              rym(iter)=max(rym(iter),abs(ry(i,j)))
  80          CONTINUE 
            ENDDO
          ENDDO
C
C     SOLVE TRIDIAGONAL SYSTEMS (AA,DD,AA) IN PARALLEL, LU DECOMPOSITION
C
          DO i = 2,n-1
            is_idx3=is_idx3+1
            WRITE(13,*) is_idx3,iter,i
            WRITE(11,*) is_idx1+1," R ","dd",2,i,2
            WRITE(12,*) is_idx2+1," R ","dd",2,i,2
            WRITE(13,*) is_idx3," R ","dd",2,i,2
            WRITE(14,*) is_idx4+1," R ","dd",2,i,2
            WRITE(15,*) is_idx5+1," R ","dd",2,i,2
            WRITE(16,*) is_idx6+1," R ","dd",2,i,2
            WRITE(17,*) is_idx7+1," R ","dd",2,i,2
            WRITE(11,*) is_idx1+1," W ","d",2,i,2
            WRITE(12,*) is_idx2+1," W ","d",2,i,2
            WRITE(13,*) is_idx3," W ","d",2,i,2
            WRITE(14,*) is_idx4+1," W ","d",2,i,2
            WRITE(15,*) is_idx5+1," W ","d",2,i,2
            WRITE(16,*) is_idx6+1," W ","d",2,i,2
            WRITE(17,*) is_idx7+1," W ","d",2,i,2
            d(i,2)=1.d0/dd(i,2)
  90        CONTINUE 
          ENDDO
          DO j = 3,n-1
            DO i = 2,n-1
              is_idx4=is_idx4+1
              WRITE(14,*) is_idx4,iter,j,i
              WRITE(11,*) is_idx1+1," R ","aa",2,i,j
              WRITE(12,*) is_idx2+1," R ","aa",2,i,j
              WRITE(13,*) is_idx3+1," R ","aa",2,i,j
              WRITE(14,*) is_idx4," R ","aa",2,i,j
              WRITE(15,*) is_idx5+1," R ","aa",2,i,j
              WRITE(16,*) is_idx6+1," R ","aa",2,i,j
              WRITE(17,*) is_idx7+1," R ","aa",2,i,j
              WRITE(11,*) is_idx1+1," R ","d",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","d",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","d",2,i,j-1
              WRITE(14,*) is_idx4," R ","d",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","d",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","d",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","d",2,i,j-1
              r=aa(i,j)*d(i,j-1)
              WRITE(11,*) is_idx1+1," R ","dd",2,i,j
              WRITE(12,*) is_idx2+1," R ","dd",2,i,j
              WRITE(13,*) is_idx3+1," R ","dd",2,i,j
              WRITE(14,*) is_idx4," R ","dd",2,i,j
              WRITE(15,*) is_idx5+1," R ","dd",2,i,j
              WRITE(16,*) is_idx6+1," R ","dd",2,i,j
              WRITE(17,*) is_idx7+1," R ","dd",2,i,j
              WRITE(11,*) is_idx1+1," R ","aa",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","aa",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","aa",2,i,j-1
              WRITE(14,*) is_idx4," R ","aa",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","aa",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","aa",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","aa",2,i,j-1
              WRITE(11,*) is_idx1+1," W ","d",2,i,j
              WRITE(12,*) is_idx2+1," W ","d",2,i,j
              WRITE(13,*) is_idx3+1," W ","d",2,i,j
              WRITE(14,*) is_idx4," W ","d",2,i,j
              WRITE(15,*) is_idx5+1," W ","d",2,i,j
              WRITE(16,*) is_idx6+1," W ","d",2,i,j
              WRITE(17,*) is_idx7+1," W ","d",2,i,j
              d(i,j)=1.d0/(dd(i,j)-aa(i,j-1)*r)
              WRITE(11,*) is_idx1+1," R ","rx",2,i,j
              WRITE(12,*) is_idx2+1," R ","rx",2,i,j
              WRITE(13,*) is_idx3+1," R ","rx",2,i,j
              WRITE(14,*) is_idx4," R ","rx",2,i,j
              WRITE(15,*) is_idx5+1," R ","rx",2,i,j
              WRITE(16,*) is_idx6+1," R ","rx",2,i,j
              WRITE(17,*) is_idx7+1," R ","rx",2,i,j
              WRITE(11,*) is_idx1+1," R ","rx",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","rx",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","rx",2,i,j-1
              WRITE(14,*) is_idx4," R ","rx",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","rx",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","rx",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","rx",2,i,j-1
              WRITE(11,*) is_idx1+1," W ","rx",2,i,j
              WRITE(12,*) is_idx2+1," W ","rx",2,i,j
              WRITE(13,*) is_idx3+1," W ","rx",2,i,j
              WRITE(14,*) is_idx4," W ","rx",2,i,j
              WRITE(15,*) is_idx5+1," W ","rx",2,i,j
              WRITE(16,*) is_idx6+1," W ","rx",2,i,j
              WRITE(17,*) is_idx7+1," W ","rx",2,i,j
              rx(i,j)=rx(i,j)-rx(i,j-1)*r
              WRITE(11,*) is_idx1+1," R ","ry",2,i,j
              WRITE(12,*) is_idx2+1," R ","ry",2,i,j
              WRITE(13,*) is_idx3+1," R ","ry",2,i,j
              WRITE(14,*) is_idx4," R ","ry",2,i,j
              WRITE(15,*) is_idx5+1," R ","ry",2,i,j
              WRITE(16,*) is_idx6+1," R ","ry",2,i,j
              WRITE(17,*) is_idx7+1," R ","ry",2,i,j
              WRITE(11,*) is_idx1+1," R ","ry",2,i,j-1
              WRITE(12,*) is_idx2+1," R ","ry",2,i,j-1
              WRITE(13,*) is_idx3+1," R ","ry",2,i,j-1
              WRITE(14,*) is_idx4," R ","ry",2,i,j-1
              WRITE(15,*) is_idx5+1," R ","ry",2,i,j-1
              WRITE(16,*) is_idx6+1," R ","ry",2,i,j-1
              WRITE(17,*) is_idx7+1," R ","ry",2,i,j-1
              WRITE(11,*) is_idx1+1," W ","ry",2,i,j
              WRITE(12,*) is_idx2+1," W ","ry",2,i,j
              WRITE(13,*) is_idx3+1," W ","ry",2,i,j
              WRITE(14,*) is_idx4," W ","ry",2,i,j
              WRITE(15,*) is_idx5+1," W ","ry",2,i,j
              WRITE(16,*) is_idx6+1," W ","ry",2,i,j
              WRITE(17,*) is_idx7+1," W ","ry",2,i,j
              ry(i,j)=ry(i,j)-ry(i,j-1)*r
 100          CONTINUE 
            ENDDO
          ENDDO
          DO i = 2,n-1
            is_idx5=is_idx5+1
            WRITE(15,*) is_idx5,iter,i
            WRITE(11,*) is_idx1+1," R ","rx",2,i,n-1
            WRITE(12,*) is_idx2+1," R ","rx",2,i,n-1
            WRITE(13,*) is_idx3+1," R ","rx",2,i,n-1
            WRITE(14,*) is_idx4+1," R ","rx",2,i,n-1
            WRITE(15,*) is_idx5," R ","rx",2,i,n-1
            WRITE(16,*) is_idx6+1," R ","rx",2,i,n-1
            WRITE(17,*) is_idx7+1," R ","rx",2,i,n-1
            WRITE(11,*) is_idx1+1," R ","d",2,i,n-1
            WRITE(12,*) is_idx2+1," R ","d",2,i,n-1
            WRITE(13,*) is_idx3+1," R ","d",2,i,n-1
            WRITE(14,*) is_idx4+1," R ","d",2,i,n-1
            WRITE(15,*) is_idx5," R ","d",2,i,n-1
            WRITE(16,*) is_idx6+1," R ","d",2,i,n-1
            WRITE(17,*) is_idx7+1," R ","d",2,i,n-1
            WRITE(11,*) is_idx1+1," W ","rx",2,i,n-1
            WRITE(12,*) is_idx2+1," W ","rx",2,i,n-1
            WRITE(13,*) is_idx3+1," W ","rx",2,i,n-1
            WRITE(14,*) is_idx4+1," W ","rx",2,i,n-1
            WRITE(15,*) is_idx5," W ","rx",2,i,n-1
            WRITE(16,*) is_idx6+1," W ","rx",2,i,n-1
            WRITE(17,*) is_idx7+1," W ","rx",2,i,n-1
            rx(i,n-1)=rx(i,n-1)*d(i,n-1)
            WRITE(11,*) is_idx1+1," R ","ry",2,i,n-1
            WRITE(12,*) is_idx2+1," R ","ry",2,i,n-1
            WRITE(13,*) is_idx3+1," R ","ry",2,i,n-1
            WRITE(14,*) is_idx4+1," R ","ry",2,i,n-1
            WRITE(15,*) is_idx5," R ","ry",2,i,n-1
            WRITE(16,*) is_idx6+1," R ","ry",2,i,n-1
            WRITE(17,*) is_idx7+1," R ","ry",2,i,n-1
            WRITE(11,*) is_idx1+1," R ","d",2,i,n-1
            WRITE(12,*) is_idx2+1," R ","d",2,i,n-1
            WRITE(13,*) is_idx3+1," R ","d",2,i,n-1
            WRITE(14,*) is_idx4+1," R ","d",2,i,n-1
            WRITE(15,*) is_idx5," R ","d",2,i,n-1
            WRITE(16,*) is_idx6+1," R ","d",2,i,n-1
            WRITE(17,*) is_idx7+1," R ","d",2,i,n-1
            WRITE(11,*) is_idx1+1," W ","ry",2,i,n-1
            WRITE(12,*) is_idx2+1," W ","ry",2,i,n-1
            WRITE(13,*) is_idx3+1," W ","ry",2,i,n-1
            WRITE(14,*) is_idx4+1," W ","ry",2,i,n-1
            WRITE(15,*) is_idx5," W ","ry",2,i,n-1
            WRITE(16,*) is_idx6+1," W ","ry",2,i,n-1
            WRITE(17,*) is_idx7+1," W ","ry",2,i,n-1
            ry(i,n-1)=ry(i,n-1)*d(i,n-1)
 110        CONTINUE 
          ENDDO
          DO j = n-2,2,-1
            DO i = 2,n-1
              is_idx6=is_idx6+1
              WRITE(16,*) is_idx6,iter,j,i
              WRITE(11,*) is_idx1+1," R ","rx",2,i,j
              WRITE(12,*) is_idx2+1," R ","rx",2,i,j
              WRITE(13,*) is_idx3+1," R ","rx",2,i,j
              WRITE(14,*) is_idx4+1," R ","rx",2,i,j
              WRITE(15,*) is_idx5+1," R ","rx",2,i,j
              WRITE(16,*) is_idx6," R ","rx",2,i,j
              WRITE(17,*) is_idx7+1," R ","rx",2,i,j
              WRITE(11,*) is_idx1+1," R ","aa",2,i,j
              WRITE(12,*) is_idx2+1," R ","aa",2,i,j
              WRITE(13,*) is_idx3+1," R ","aa",2,i,j
              WRITE(14,*) is_idx4+1," R ","aa",2,i,j
              WRITE(15,*) is_idx5+1," R ","aa",2,i,j
              WRITE(16,*) is_idx6," R ","aa",2,i,j
              WRITE(17,*) is_idx7+1," R ","aa",2,i,j
              WRITE(11,*) is_idx1+1," R ","rx",2,i,j+1
              WRITE(12,*) is_idx2+1," R ","rx",2,i,j+1
              WRITE(13,*) is_idx3+1," R ","rx",2,i,j+1
              WRITE(14,*) is_idx4+1," R ","rx",2,i,j+1
              WRITE(15,*) is_idx5+1," R ","rx",2,i,j+1
              WRITE(16,*) is_idx6," R ","rx",2,i,j+1
              WRITE(17,*) is_idx7+1," R ","rx",2,i,j+1
              WRITE(11,*) is_idx1+1," R ","d",2,i,j
              WRITE(12,*) is_idx2+1," R ","d",2,i,j
              WRITE(13,*) is_idx3+1," R ","d",2,i,j
              WRITE(14,*) is_idx4+1," R ","d",2,i,j
              WRITE(15,*) is_idx5+1," R ","d",2,i,j
              WRITE(16,*) is_idx6," R ","d",2,i,j
              WRITE(17,*) is_idx7+1," R ","d",2,i,j
              WRITE(11,*) is_idx1+1," W ","rx",2,i,j
              WRITE(12,*) is_idx2+1," W ","rx",2,i,j
              WRITE(13,*) is_idx3+1," W ","rx",2,i,j
              WRITE(14,*) is_idx4+1," W ","rx",2,i,j
              WRITE(15,*) is_idx5+1," W ","rx",2,i,j
              WRITE(16,*) is_idx6," W ","rx",2,i,j
              WRITE(17,*) is_idx7+1," W ","rx",2,i,j
              rx(i,j)=(rx(i,j)-aa(i,j)*rx(i,j+1))*d(i,j)
              WRITE(11,*) is_idx1+1," R ","ry",2,i,j
              WRITE(12,*) is_idx2+1," R ","ry",2,i,j
              WRITE(13,*) is_idx3+1," R ","ry",2,i,j
              WRITE(14,*) is_idx4+1," R ","ry",2,i,j
              WRITE(15,*) is_idx5+1," R ","ry",2,i,j
              WRITE(16,*) is_idx6," R ","ry",2,i,j
              WRITE(17,*) is_idx7+1," R ","ry",2,i,j
              WRITE(11,*) is_idx1+1," R ","aa",2,i,j
              WRITE(12,*) is_idx2+1," R ","aa",2,i,j
              WRITE(13,*) is_idx3+1," R ","aa",2,i,j
              WRITE(14,*) is_idx4+1," R ","aa",2,i,j
              WRITE(15,*) is_idx5+1," R ","aa",2,i,j
              WRITE(16,*) is_idx6," R ","aa",2,i,j
              WRITE(17,*) is_idx7+1," R ","aa",2,i,j
              WRITE(11,*) is_idx1+1," R ","ry",2,i,j+1
              WRITE(12,*) is_idx2+1," R ","ry",2,i,j+1
              WRITE(13,*) is_idx3+1," R ","ry",2,i,j+1
              WRITE(14,*) is_idx4+1," R ","ry",2,i,j+1
              WRITE(15,*) is_idx5+1," R ","ry",2,i,j+1
              WRITE(16,*) is_idx6," R ","ry",2,i,j+1
              WRITE(17,*) is_idx7+1," R ","ry",2,i,j+1
              WRITE(11,*) is_idx1+1," R ","d",2,i,j
              WRITE(12,*) is_idx2+1," R ","d",2,i,j
              WRITE(13,*) is_idx3+1," R ","d",2,i,j
              WRITE(14,*) is_idx4+1," R ","d",2,i,j
              WRITE(15,*) is_idx5+1," R ","d",2,i,j
              WRITE(16,*) is_idx6," R ","d",2,i,j
              WRITE(17,*) is_idx7+1," R ","d",2,i,j
              WRITE(11,*) is_idx1+1," W ","ry",2,i,j
              WRITE(12,*) is_idx2+1," W ","ry",2,i,j
              WRITE(13,*) is_idx3+1," W ","ry",2,i,j
              WRITE(14,*) is_idx4+1," W ","ry",2,i,j
              WRITE(15,*) is_idx5+1," W ","ry",2,i,j
              WRITE(16,*) is_idx6," W ","ry",2,i,j
              WRITE(17,*) is_idx7+1," W ","ry",2,i,j
              ry(i,j)=(ry(i,j)-aa(i,j)*ry(i,j+1))*d(i,j)
 120          CONTINUE 
            ENDDO
          ENDDO
C
C     ADD CORRECTIONS OF ITER ITERATION
C
          DO j = 2,n-1
            DO i = 2,n-1
              is_idx7=is_idx7+1
              WRITE(17,*) is_idx7,iter,j,i
              WRITE(11,*) is_idx1+1," R ","x",2,i,j
              WRITE(12,*) is_idx2+1," R ","x",2,i,j
              WRITE(13,*) is_idx3+1," R ","x",2,i,j
              WRITE(14,*) is_idx4+1," R ","x",2,i,j
              WRITE(15,*) is_idx5+1," R ","x",2,i,j
              WRITE(16,*) is_idx6+1," R ","x",2,i,j
              WRITE(17,*) is_idx7," R ","x",2,i,j
              WRITE(11,*) is_idx1+1," R ","rx",2,i,j
              WRITE(12,*) is_idx2+1," R ","rx",2,i,j
              WRITE(13,*) is_idx3+1," R ","rx",2,i,j
              WRITE(14,*) is_idx4+1," R ","rx",2,i,j
              WRITE(15,*) is_idx5+1," R ","rx",2,i,j
              WRITE(16,*) is_idx6+1," R ","rx",2,i,j
              WRITE(17,*) is_idx7," R ","rx",2,i,j
              WRITE(11,*) is_idx1+1," W ","x",2,i,j
              WRITE(12,*) is_idx2+1," W ","x",2,i,j
              WRITE(13,*) is_idx3+1," W ","x",2,i,j
              WRITE(14,*) is_idx4+1," W ","x",2,i,j
              WRITE(15,*) is_idx5+1," W ","x",2,i,j
              WRITE(16,*) is_idx6+1," W ","x",2,i,j
              WRITE(17,*) is_idx7," W ","x",2,i,j
              x(i,j)=x(i,j)+rx(i,j)
              WRITE(11,*) is_idx1+1," R ","y",2,i,j
              WRITE(12,*) is_idx2+1," R ","y",2,i,j
              WRITE(13,*) is_idx3+1," R ","y",2,i,j
              WRITE(14,*) is_idx4+1," R ","y",2,i,j
              WRITE(15,*) is_idx5+1," R ","y",2,i,j
              WRITE(16,*) is_idx6+1," R ","y",2,i,j
              WRITE(17,*) is_idx7," R ","y",2,i,j
              WRITE(11,*) is_idx1+1," R ","ry",2,i,j
              WRITE(12,*) is_idx2+1," R ","ry",2,i,j
              WRITE(13,*) is_idx3+1," R ","ry",2,i,j
              WRITE(14,*) is_idx4+1," R ","ry",2,i,j
              WRITE(15,*) is_idx5+1," R ","ry",2,i,j
              WRITE(16,*) is_idx6+1," R ","ry",2,i,j
              WRITE(17,*) is_idx7," R ","ry",2,i,j
              WRITE(11,*) is_idx1+1," W ","y",2,i,j
              WRITE(12,*) is_idx2+1," W ","y",2,i,j
              WRITE(13,*) is_idx3+1," W ","y",2,i,j
              WRITE(14,*) is_idx4+1," W ","y",2,i,j
              WRITE(15,*) is_idx5+1," W ","y",2,i,j
              WRITE(16,*) is_idx6+1," W ","y",2,i,j
              WRITE(17,*) is_idx7," W ","y",2,i,j
              y(i,j)=y(i,j)+ry(i,j)
 130          CONTINUE 
            ENDDO
          ENDDO
C
 140      CONTINUE 
        ENDDO
C
C     OUTPUT OF CONVERGENCE BEHAVIOR
C
        WRITE(6,1100) 
        WRITE(6,1200) 
        CLOSE(17) 
        CLOSE(16) 
        CLOSE(15) 
        CLOSE(14) 
        CLOSE(13) 
        CLOSE(12) 
        CLOSE(11) 
        OPEN(unit=11,file='tomcatv.isg.8')
        is_idx1=0
        DO i = 1,iter-1
          is_idx1=is_idx1+1
          WRITE(11,*) is_idx1,i
          WRITE(11,*) is_idx1," R ","rxm",1,i
          WRITE(11,*) is_idx1," R ","rym",1,i
          WRITE(6,1300) i,rxm(i),rym(i)
 160      CONTINUE 
        ENDDO
C
 600    FORMAT(d20.14,d20.14)
1100    FORMAT(///,"     2-D ITERATION BEHAVIOR")
1200    FORMAT(/,"   IT    X-RES      Y-RES",/)
1300    FORMAT(1x,i4,e11.4,e11.4)
C 
        CALL cputim(cputim2)
        PRINT *,cputim2-cputim1
        STOP
        END

        SUBROUTINE cputim(t)
        REAL t
        REAL*4 tarray(2),etime
        t=etime(tarray)
        t=tarray(1)
        RETURN 
        END
